

% 21.2.2013
% Robert Kollmann, robert_kollmann@yahoo.com
% SIMPLE RBC MODEL WITH TFP AND TASTE (PSI) SHOCKS

function [xq]=RBCmodf(z); 
global BETA CRRA ELS KPSI DEPRECss PSIss THss RHOth RHOpsi  

if rows(z)~=16;  error('incorrect number of inputs'); end;

k=exp(z(1,:));    % k(t+1): capital stock at end of period t
gdp=exp(z(2,:));  % GDP(t)
c=exp(z(3,:));    % c(t)
I=exp(z(4,:));    % I(t)
Lab=exp(z(5,:));  % Labor(t)
th=exp(z(6,:));   % TFP(t)
psi=exp(z(7,:));  % Labor supply shock(t)

KK=7;
% Lagged variables
kL=exp(z(KK+1,:));     % k(t)
gdpL=exp(z(KK+2,:));   % GDP(t-1)
cL=exp(z(KK+3,:));     % c(t-1)
IL=exp(z(KK+4,:));     % I(t-1)
LabL=exp(z(KK+5,:));   % Labor(t-1)
thL=exp(z(KK+6,:));    % TFP(t-1)
psiL=exp(z(KK+7,:));   % Labor supply shock(t-1) 

% innovations to exogenous variables
Eth=z(2*KK+1,:);
Epsi=z(2*KK+2,:);

x1=-1 + (psiL/PSIss).*BETA.*((c./cL).^-CRRA).*(KPSI.*th.*kL.^(KPSI-1).*Lab.^(1-KPSI)+1-DEPRECss);
x2=-c-I+gdp;
x3=(-(c.^-CRRA).*th.*(kL.^KPSI).*(1-KPSI).*(Lab.^-KPSI)+PSIss.*(Lab.^(1/ELS)))/PSIss;
x4=-k + (1-DEPRECss).*kL+I;
x5=-gdp+th.*kL.^KPSI.*Lab.^(1-KPSI);
x6=-log(th/THss) + RHOth.*log(thL/THss) + Eth;
x7=-log(psi/PSIss) + RHOpsi*log(psiL/PSIss) + Epsi;


xq=[x1;x2;x3;x4;x5;x6;x7];    

% save klm
if rows(xq)~=7; error('QQQQQQQQ'); end;

