
function R=cholPSD(S)
% March 8, 2013
% Robert Kollmann, robert_kollmann@yahoo.com
% Let 'S' be an NxN covariance matrix, i.e. 'S' is symmetric & positive semi-definite (PSD).
% Note that 'S' may be singular (as is the case for a covariance matrix of
% linearly dependent random variables, or when one or more of the random
% variabls have zero variance).
% The output 'R' is such that S=R'*R
% When e is a Nx1 random vector with Ee*e'=I, then u=R'*e is such that
% E(u*u')=S
% IF 'S' IS NOT positive definite, then can use the cholPSD proc 
% to generate a random variable with covariance matrix 'S' 
% (as the Choleski decomposition cannot be used in this case


%if maxaa(S-S')>trace(abs(S))*1e-8; error('need symmetric matrix'); end;

SS=(S+S')/2;
[V,D]=eig(SS);

if min(diag(D))<=-(1e-7)*max([.0001; max(diag(D))]); error('Need eigenvalues >=0 '); end;


R1=sqrt(abs(D))*V';

if maxaa(imag(R1))>1e-7; error('AA1'); end;
R=real(R1);

%save klm999;
if maxaa(SS-R'*R)>1e-7; error('AAA'); end;

