

function [F0,F1,F2,F11,F12,F22]=gensys2_TO_KALMANQ(FD,FDD,M11,M2,pick,zu,sig);
% February 24, 2012
% Robert Kollmann, robert_kollmann@yahoo.com
% This proc uses and inputs information provided by gensy2, and it
% rearranges the FF, FDD, M11, M2m matrices to produce the coefficients
% of the laws of motion of the states, needed for the KALMANQ procedure:
% w(t+1)=F0+F1*w(t)+F2*e(t+1)+F11*polynom2(w(t))+ ...
%    F12*polynom2ALL(w(t),e(t+1))+F22*polynom2(e(t+1))

if nargin~=7; error('AAA'); end;

FD1=(FD{1});
FD2=(FD{2});
FD3=(FD{3});
FD11=(FDD{1,1});
FD12=(FDD{1,2});
FD22=(FDD{2,2});

Z=[pick;zu];
Z1=pick;

IZ=inv(Z);
F0=IZ*[FD3;M2]*sig^2;
F1=IZ*[FD1*Z1;zeros(rows(zu),cols(Z))];
F2=IZ*[FD2;zeros(rows(zu),cols(FD2))];

KuK=size(M11); 
if (KuK(2)+rows(M2))~=(rows(pick)+rows(zu)); error('AA'); end;


% ====================== F11 ================================
%H11a=zeros(rows(Z),rows(Z),rows(Z));
%i=1; while i<=rows(FD11);
%H11a(i,:,:)=Z1'*squeeze(FD11(i,:,:))*Z1;
%i=i+1; end;

A11=.5*prodt(prodt(FD11,Z1,2,1),Z1,2,1);
B11=.5*prodt(prodt(M11,FD1*Z1,2,1),FD1*Z1,2,1);
C11=zeros(rows(Z),rows(Z),rows(Z));
C11(1:rows(Z1),:,:)=A11;
C11(rows(Z1)+1:end,:,:)=B11;

HD11=prodt(IZ,C11,2,1);

%K11=zeros(size(H11));
%i=1; while i<=rows(Z);
%resi=0;
%k=1; while k<=rows(Z);
%resi=resi+IZ(i,k)*squeeze(C11(k,:,:));
%k=k+1; end;
%K11(i,:,:)=.5*resi;
%=i+1; end;

F11=[];
i=1; while i<=rows(Z);
xyz=squeeze(HD11(i,:,:));
cdf=(xyz+xyz')-diag(diag(xyz));
F11=[F11; vech1(cdf)'];
i=i+1; end;

%w=randn(rows(Z),1); maxaa([prodt(prodt(HD11,w,2,1),w,2,1)-F11*polynom2(w')'])

% ===================== F12 =========================
% ...........................................................
DETAIL_H12=0;
if DETAIL_H12==1;
A12=zeros(rows(pick),rows(Z),cols(F2));
i=1; while i<=rows(pick);
A12(i,:,:)=Z1'*squeeze(FD12(i,:,:));
i=i+1; end;

B12=zeros(rows(zu),rows(Z),cols(F2));
i=1; while i<=rows(zu);
B12(i,:,:)=Z1'*FD1'*squeeze(M11(i,:,:))*FD2;    
i=i+1; end;
    
C12=zeros(rows(Z),rows(Z),cols(F2));
C12(1:rows(pick),:,:)=A12;
C12(rows(pick)+1:end,:,:)=B12;
D12=prodt(IZ,H12,2,1);
end;  % enf if DETAIL_H12==1;
% .........................................................


Q12=prodt(FD12,Z1,2,1);
R12=prodt(prodt(M11,FD2,2,1),FD1*Z1,2,1);
S12=zeros(rows(Z),cols(F2),rows(Z));
S12(1:rows(pick),:,:)=Q12;
S12(rows(pick)+1:end,:,:)=R12;
HD12=prodt(IZ,S12,2,1);
%w=randn(8,1); e=randn(2,1); 
%maxaa(prodt(prodt(C12,w,2,1),e,2,1)-prodt(prodt(S12,e,2,1),w,2,1))

F12=[];
i=1; while i<=rows(Z);
psc=squeeze(HD12(i,:,:));
F12=[F12; psc(:)'];
i=i+1; end;

%w=randn(rows(Z),1); e=randn(cols(F2),1); 
%maxaa(F12*kron(w,e)-prodt(prodt(HD12,e,2,1),w,2,1))

% ==================== F22 ===============================
C22=zeros(rows(Z),cols(F2),cols(F2));
C22(1:rows(pick),:,:)=.5*FD22;
C22(rows(pick)+1:end,:,:)=.5*prodt(prodt(M11,FD2,2,1),FD2,2,1);
HD22=prodt(IZ,C22,2,1);

F22=[];
i=1; while i<=rows(Z);
xyz=squeeze(HD22(i,:,:));
pvv=(xyz+xyz')-diag(diag(xyz));
F22=[F22; vech1(pvv)'];
i=i+1; end;

% e=randn(cols(F2),1); maxaa([prodt(prodt(HD22,e,2,1),e,2,1)-F22*polynom2(e')'])


